using System;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Media3D;

namespace TestProject
{
    /// <summary>
    ///  Ǹ ޽
    /// </summary>
    public class HollowCylinderMesh : CylindricalMeshBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - HollowCylinderMesh()

        /// <summary>
        /// 
        /// </summary>
        public HollowCylinderMesh()
        {
            PropertyChanged(new DependencyPropertyChangedEventArgs());
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region ﰢ ϱ - Triangulate(e, vertexCollection, normalCollection, indexCollection, textureCollection)

        /// <summary>
        /// ﰢ ϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        /// <param name="vertexCollection"> ÷</param>
        /// <param name="normalCollection"> ÷</param>
        /// <param name="indexCollection">ε ÷</param>
        /// <param name="textureCollection">ؽó ÷</param>
        protected override void Triangulate(DependencyPropertyChangedEventArgs e, Point3DCollection vertexCollection, Vector3DCollection normalCollection, Int32Collection indexCollection, PointCollection textureCollection)
        {
            vertexCollection.Clear();
            normalCollection.Clear();
            indexCollection.Clear();
            textureCollection.Clear();

            for(int stack = 0; stack <= StackCount; stack++)
            {
                double y = Length - stack * Length / StackCount;

                for(int slice = 0; slice <= SliceCount; slice++)
                {
                    double theta = slice * 2 * Math.PI / SliceCount;
                    double x     = -Radius * Math.Sin(theta);
                    double z     = -Radius * Math.Cos(theta);

                    normalCollection.Add(new Vector3D(x, 0, z));
                    vertexCollection.Add(new Point3D(x, y, z));
                    textureCollection.Add(new Point((double)slice / SliceCount, (double)stack / StackCount));
                }
            }

            for(int stack = 0; stack < StackCount; stack++)
            {
                for(int slice = 0; slice < SliceCount; slice++)
                {
                    indexCollection.Add((stack + 0) * (SliceCount + 1) + slice    );
                    indexCollection.Add((stack + 1) * (SliceCount + 1) + slice    );
                    indexCollection.Add((stack + 0) * (SliceCount + 1) + slice + 1);

                    indexCollection.Add((stack + 0) * (SliceCount + 1) + slice + 1);
                    indexCollection.Add((stack + 1) * (SliceCount + 1) + slice    );
                    indexCollection.Add((stack + 1) * (SliceCount + 1) + slice + 1);
                }
            }
        }

        #endregion
        #region νϽ ϱ (ھ) - CreateInstanceCore()

        /// <summary>
        /// νϽ ϱ (ھ)
        /// </summary>
        /// <returns>νϽ</returns>
        protected override Freezable CreateInstanceCore()
        {
            return new HollowCylinderMesh();
        }

        #endregion
    }
}